%% testing find_cluster, using 5 by 8 space.
maxX=5;maxY=8;
mat=zeros(maxX*maxY,maxX*maxY);
mask=[-1 -1; -1 0; -1 1;
       0 -1;     ;  0 1;
       1 -1;  1 0;  1 1];
node_index=zeros(maxX,maxY);k=1;
for j=1:maxY
    for i=1:maxX
        node_index(i,j)=k;
        k=k+1;
    end
end
for j=1:maxY
    for i=1:maxX
        x=mask(:,1)+i;               y=mask(:,2)+j;
        idxX=find(x>0 & x<=maxX);   idxY=find(y>0 & y<=maxY);
        idx=intersect(idxX,idxY);
        adj=[x(idx),y(idx)];
        start=node_index(i,j);
        for k=1:length(idx)
            target=node_index(adj(k,1),adj(k,2));
            mat(start,target)=1; mat(target,start)=1;
        end
    end
end
% replace the findings to 1.
findings=[0 0 1 0 0 0 0 0;
          0 1 1 1 0 0 0 0;
          0 1 1 0 0 1 0 0;
          0 0 0 0 1 1 1 0;
          0 0 0 0 0 0 1 0];
[i,j]=find(findings);
nodes=zeros(length(i),1);
for k=1:length(i)
    nodes(k)=node_index(i(k),j(k));
end
% THE ROUTINE.
tic
% c=find_cluster_node(nodes,mat);
c=find_cluster_node(nodes,mat);
toc

% showing results.
map=zeros(maxX,maxY);
for i=1:length(c)
    map(c{i})=i;
end
imagesc(map)
